-- Ask Talkback App on thingspeak.com for new commands
LED_Pin = 0

--- Get values and send data to thingspeak.com
function getCommandsFromTalkback()
    
    -- connection handle
    conn = net.createConnection(net.TCP, 0) 
    
    -- register all callback functions for TCP communication
    -- callback function for TCP Receive
    conn:on("receive", function(conn, payloadout)
  --      print(payloadout)
        if (string.find(payloadout, "Status: 200 OK") ~= nil) then
            --receive successfull, start parsing the Command
            if (string.find(payloadout, "Length") ~= nil) then
                offset = string.find(payloadout, "Length")  --parse the Length of Content
                offset = offset + 8
                endstring = string.find(payloadout, "\r", offset)

                cmdlen = string.sub(payloadout, offset, endstring) --length of HTTP Content -> our Cmd Length
    
                strlen = string.len(payloadout)     --total length of HTTP answer
    
                cmd = string.sub(payloadout,strlen - cmdlen, strlen)    --Cmd is last part of HTTP Content
    
                print(cmd)  --Print Cmd
             
            else
                print("parser error")
            end

        else
            print("Get Command error")
        end


        if (string.match(cmd, "LED ON") ~= nil) then
            cmdLedOn()
        elseif (string.match(cmd, "LED OFF") ~= nil) then
            cmdLedOff()
        end
          
    end)
    
    -- callback function for TCP Connection
    conn:on("connection", function(conn, payloadout)
 
        print ("Getting Command... ")

        ---- callback function for TCP Send
        conn:send("GET /talkbacks/6862/commands/execute?api_key=9IVWUKNM5A7CLQ5E"
        .. " HTTP/1.1\r\n"
        .. "Host: api.thingspeak.com\r\n"
        .. "Connection: close\r\n"
        .. "Accept: */*\r\n"
        .. "User-Agent: Mozilla/4.0 (compatible; esp8266 Lua; Windows NT 5.1)\r\n"
        .. "\r\n")

        collectgarbage();
    end)

    -- callback function for TCP Disconnection
    conn:on("disconnection", function(conn, payloadout)
        conn:close();
        collectgarbage();
    end)

--open connection to thingspeak API    
conn:connect(80,'api.thingspeak.com')
end

function cmdLedOn()
    gpio.write(LED_Pin, 0) 
end

function cmdLedOff()
    gpio.write(LED_Pin, 1) 
end


--run the posting funcion once
getCommandsFromTalkback()
-- start Timer to send data every 30 sec
tmr.alarm(3, 30000, 1, function() getCommandsFromTalkback() end )
