
--init.lua
LED_Pin = 0

ConnectionTry = 0

gpio.mode(LED_Pin, gpio.OUTPUT)
gpio.write(LED_Pin, 0)

SSID = {"AndroidAP","Scheune",  "Scheune2",  "weissichnet", "AndroidAP"}
PASS = {"dorfstr37","dorfstr37", "dorfstr37", "dorfstr37",   "00000000"}

--Setting up Wifi
wifi.setmode(wifi.STATION)
--wireless network settings
--wifi.sta.config("AndroidAP","00000000")
print("Connecting to wifi...")

wifi.sta.connect()
wifi.sta.eventMonReg(wifi.STA_GOTIP, function() Success() end)
wifi.sta.eventMonStart()

ipAddr = wifi.sta.getip()
if ( ( ipAddr == nil ) or  ( ipAddr == "0.0.0.0" ) ) then
  -- We aren't connected, so let's connect
  print("Setting up WIFI...")
--  wifi.sta.config(SSID[ConnectionTry] , PASS[ConnectionTry])
  print("Waiting for connection")
  
  tmr.alarm(0,10000,tmr.ALARM_AUTO, function() Failure() end) --check if connection established successfully

   
else
 -- We are connected, so just run the launch code.
    Success()
end
-- Drop through here to let NodeMcu run



--callback if Wifi Connection established Successfully
function Success()
    tmr.stop(0)
    print("IP: " .. wifi.sta.getip())
    wifi.sta.eventMonStop()
    wifi.sta.eventMonReg(wifi.STA_GOTIP, "unreg")
    gpio.write(LED_Pin, 1)
    --start Sensor Readout
    if(file.open("ReadValues.lua")) then
        file.close()
        dofile("ReadValues.lua")
    else
        print("file ReadValues.lua not found")
    end

    if(file.open("Telnet.lua")) then
        file.close()
        dofile("Telnet.lua")
    else
        print("file Telnet.lua not found")
    end

        --start Sensor Readout
    if(file.open("ReadValues.lc")) then
        file.close()
        dofile("ReadValues.lc")
    else
        print("file ReadValues.lc not found")
    end

    if(file.open("Telnet.lc")) then
        file.close()
        dofile("Telnet.lc")
    else
        print("file Telnet.lc not found")
    end
    
end



--Timeout
function Failure()
        
        ConnectionTry = ConnectionTry + 1
        
        if (ConnectionTry == 6) then
            print("Unable to connect")
            ConnectionTry = 1
            wifi.sta.eventMonStop()
            wifi.sta.eventMonReg(wifi.STA_GOTIP, "unreg")
            return 0
        end
        
        print(SSID[ConnectionTry],PASS[ConnectionTry])
        wifi.sta.config(SSID[ConnectionTry] , PASS[ConnectionTry])
end
